
var WindowPostMessage = function(type, reqId, obj){
  window.postMessage({
    source: "vrest_ext",
    type: type,
    reqId : reqId,
    secret_key: "vrest_message_key",
    oArgs : obj
  }, BaseUrl);
}, BaseUrl;

window.addEventListener("message", function(event) {
  if(event.data.secret_key &&
    (event.data.secret_key === "vrest_message_key") &&
     event.data.source === "vrest_page"){
    
    if(event.data.type && event.data.reqId){
      var madecb = WindowPostMessage.bind(undefined,event.data.type,event.data.reqId);
      switch(event.data.type) {
        case 'version_info':
          if(BaseUrl === undefined) BaseUrl = event.data.baseUrl;
          madecb({ version: chrome.runtime.getManifest().version });
          break;
        case 'abortrequest':
          chrome.runtime.sendMessage(chrome.runtime.id, {message:'abortrequest'});
          break;
        case 'testcase':
          chrome.runtime.sendMessage(chrome.runtime.id, event.data.oArgs, madecb);
          break;
        case 'callrest':
          chrome.runtime.sendMessage(chrome.runtime.id, {
            message : 'callrest',
            data : event.data.oArgs
          }, madecb);
          break;
        default:
          WindowPostMessage('err_data', event.data.reqId, {err: 'Invalid arguments for execution.'});
      }
    }
  }
}, false);
