import ApplicationSource from "../interfaces/ApplicationSource";
import { Instance, Project, MetaData, RecorderConfig, DiagnosticsResult } from "../interfaces/types";
export default class CloudImpl implements ApplicationSource {
    private orgUserId;
    getBaseURL(): any;
    readInstances(): Promise<Instance[]>;
    readProjects(instanceName: string): Promise<Project[]>;
    readMetaData(instanceName: string, projectId: string): Promise<MetaData>;
    readRecorderConfig(instanceName: string): Promise<RecorderConfig>;
    saveRecorderConfiguration(instanceName: string, config: RecorderConfig): Promise<import("axios").AxiosResponse<any>>;
    diagnoseExtension(instanceName: any): Promise<DiagnosticsResult>;
    createTestCase(instanceName: any, data: any): Promise<any>;
}
