import ApplicationSource from "../interfaces/ApplicationSource";
import { Instance, Project, MetaData, RecorderConfig, DiagnosticsResult } from "../interfaces/types";
export default class NGImpl implements ApplicationSource {
    readInstances(): Promise<Instance[]>;
    __handleRequest(reqObj: any): Promise<any>;
    readProjects(instanceId: string): Promise<Project[]>;
    readMetaData(instanceName: string, projectId: string): Promise<MetaData>;
    readRecorderConfig(instanceName: string): Promise<RecorderConfig>;
    saveRecorderConfiguration(instanceName: string, config: RecorderConfig): Promise<any>;
    diagnoseExtension(instanceName: any): Promise<DiagnosticsResult>;
    createTestCase(instanceName: any, data: any): Promise<any>;
}
